//+------------------------------------------------------------------+
//|                                                    Portfolio.mq4 |
//|                     Copyright  2011, Victor Niclolaev aka Vinin |
//|                                                    vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Victor Niclolaev aka Vinin"
#property link      "vinin@mail.ru"


#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Green
#property indicator_color2 Lime
#property indicator_color3 Brown
#property indicator_color4 Red
#property indicator_color5 Silver


#property indicator_width1 1
#property indicator_width2 2
#property indicator_width3 1
#property indicator_width4 2
#property indicator_width5 2

#property indicator_level1 0

extern int Id=1;

extern string sBuy_currency_pairs = "----- List of Buy currency pairs -----";
extern string sBuy_pair = "USDCHF,EURGBP,GBPUSD,NZDUSD,EURJPY,AUDJPY,GBPJPY";
extern string sSell_currency_pairs = "----- List of Sell currency pairs -----";
extern string sSell_pair = "AUDUSD,NZDJPY,CHFJPY,USDJPY,EURUSD,EURCHF,GBPCHF"; 



string asBuy_pair[7], asSell_pair[7];


//--- buffers
double ExtMapBuffer1[]; //  
double ExtMapBuffer2[]; //  
double ExtMapBuffer3[]; //  
double ExtMapBuffer4[]; //  
double ExtMapBuffer5[]; //  

string Name1="", Name2="";
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0, EMPTY);
   SetIndexLabel(0,NULL);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(1, EMPTY);
   SetIndexLabel(1,NULL);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexEmptyValue(2, EMPTY);
   SetIndexLabel(2,NULL);
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexEmptyValue(3, EMPTY);
   SetIndexLabel(3,NULL);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexEmptyValue(4, EMPTY);
   SetIndexLabel(4,"Portfolio");

   
   Parser(asBuy_pair,sBuy_pair);
   Parser(asSell_pair,sSell_pair);
   Name1="Start"+Id;
   Name2="Start"+(Id+1);
   
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
   if (ObjectFind(Name1)!=-1) ObjectDelete(Name1);
   if (ObjectFind(Name2)!=-1) ObjectDelete(Name2);
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i, pos;
   if (ObjectFind(Name1)==-1)
      ObjectCreate(Name1,OBJ_VLINE, 0, iTime(NULL, PERIOD_D1,0),0);
   int StartTime=ObjectGet(Name1,OBJPROP_TIME1);
   int StartPos=iBarShift(NULL,0, StartTime);
   
   double sum;
   ArrayInitialize(ExtMapBuffer1,EMPTY);
   ArrayInitialize(ExtMapBuffer2,EMPTY);
   ArrayInitialize(ExtMapBuffer3,EMPTY);
   
   ArrayInitialize(ExtMapBuffer4,EMPTY);
   ArrayInitialize(ExtMapBuffer5,EMPTY);

   for (i=0;i<7;i++) {
      if (CheckHistory(asBuy_pair[i])==false) {
         Print("   ",asBuy_pair[i]);
         return(0);
      }
      if (CheckHistory(asSell_pair[i])==false) {
         Print("   ",asSell_pair[i]);
         return(0);
      }
   }
   double Max=0;
   int posMax=-1;
   for (pos=StartPos;pos>=0;pos--) {
      sum=0; for (i=0;i<7;i++) {
         sum+=CalcProfit(asBuy_pair[i],Time[StartPos],Time[pos]);
         sum+=CalcProfit(asSell_pair[i],Time[StartPos],Time[pos]);
      }
      ExtMapBuffer5[pos]=sum;
      if (Max<MathAbs(sum)) {
         Max=MathAbs(sum);
         posMax=pos;
      }
      if (sum>0) {
         ExtMapBuffer2[pos]=0;
         ExtMapBuffer3[pos]=0;
         ExtMapBuffer4[pos]=0;         
         ExtMapBuffer1[pos]=sum;
         if (ExtMapBuffer1[pos]>=ExtMapBuffer1[pos+1]) ExtMapBuffer2[pos]=sum;
         
      } else  if (sum<0)  {
         ExtMapBuffer1[pos]=0; 
         ExtMapBuffer2[pos]=0;
         ExtMapBuffer3[pos]=sum;
         ExtMapBuffer4[pos]=0;         
         if (ExtMapBuffer3[pos]<=ExtMapBuffer3[pos+1]) ExtMapBuffer4[pos]=sum;
      }
   }
      
   if (ObjectFind(Name2)==-1)
      ObjectCreate(Name2,OBJ_VLINE, 0, Time[posMax],0);
   else 
      ObjectSet(Name2,OBJPROP_TIME1, Time[posMax]);
   

   return(0);
  }
//+------------------------------------------------------------------+

void Parser(string & sArray[], string sList){
   int i=0;
   int n1=0;
   int n2=StringFind(sList,",",n1);
   while (n2>-1) {
      sArray[i]=StringSubstr(sList, n1,n2-n1);
      i++;
      n1=n2+1;
      n2=StringFind(sList,",",n1);
   }
   sArray[i]=StringSubstr(sList, n1);
}

bool CheckHistory(string lSymbol){
   GetLastError();
   if (iTime(lSymbol,0,0)==0) return(false);
   if (GetLastError()==4066) return(false);
   return(true);
}

double CalcProfit(string lSymbol, int TimeStart, int TimeStop){
   double Res=0;
   int StartPos, StopPos;
   StartPos=iBarShift(lSymbol,0,TimeStart);
   StopPos=iBarShift(lSymbol,0,TimeStop);
   Res=iClose(lSymbol,0,StopPos);
   Res-=iOpen(lSymbol,0,StartPos);
   Res*=MarketInfo(lSymbol,MODE_TICKVALUE);
   Res/=MarketInfo(lSymbol,MODE_POINT);
   return(Res);
}